
/*
  lconf_session.c -- Declare api functions for creating and destorying sessions
  Copyright (C) 2018  Charlie Sale

  This file is part of cconf

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <cconf/cconf.h>
#include <cconf/kvtab.h>
#include <cconf/types.h>
#include <stdlib.h>

cconf_t *
cconf_new(void)
{
  cconf_t *tmp = malloc(sizeof(cconf_t));
  if (!tmp)
    return NULL;

  // Initiate the internals
  tmp->kvtab   = lcc_kvtab_new();
  if (!tmp->kvtab)
    {
      free(tmp);
      return NULL;
    }
  tmp->path    = NULL;
  tmp->changes = 0;

  return tmp;
}

void
cconf_free(cconf_t *lconf)
{
  if (!lconf)
    return;

  lcc_kvtab_deinit(lconf->kvtab);
  free(lconf);
}
